FPGAMAP = {
    "system": {
        "slaves": {
            "system": {
                "fields": {
                    "args_magic_number": {
                        "access_mode": "SP",
                        "bit_offset": 0,
                        "default": 4184502273,
                        "description": "args magic number for address 0",
                        "start": 0,
                        "step": 1,
                        "stop": 1,
                        "width": 32,
                    },
                    "args_map_build": {
                        "access_mode": "SP",
                        "bit_offset": 0,
                        "default": 0x12345678,
                        "description": "args map build date & hour",
                        "start": 1,
                        "step": 1,
                        "stop": 2,
                        "width": 32,
                    },
                    "build_date": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Build Date of firmware, Day/Month/Year, readable in HEX, hand coded and not tied to autogeneration currently",
                        "start": 4,
                        "step": 1,
                        "stop": 5,
                        "width": 32,
                    },
                    "eth100g_fec_enable": {
                        "access_mode": "RW",
                        "bit_offset": 4,  # changed for testing bitfield
                        "default": 0,
                        "description": "Set to 1 to enable FEC, 0 to disable",
                        "start": 16,
                        "step": 1,
                        "stop": 17,
                        "width": 1,
                    },
                    "eth100g_fec_whole_bitfield": {  # added for testing bitfield
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "For testing bitfield operations",
                        "start": 16,
                        "step": 1,
                        "stop": 17,
                        "width": 32,
                    },
                    "eth100g_locked": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "100G ethernet is up",
                        "start": 11,
                        "step": 1,
                        "stop": 12,
                        "width": 1,
                    },
                    "eth100g_rx_bad_code": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets received on the 100G ethernet with 64B/66B code violations",
                        "start": 14,
                        "step": 1,
                        "stop": 15,
                        "width": 32,
                    },
                    "eth100g_rx_bad_fcs": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets received on the 100G ethernet with bad FCS since it was reset",
                        "start": 13,
                        "step": 1,
                        "stop": 14,
                        "width": 32,
                    },
                    "eth100g_rx_total_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets received on the 100G ethernet since it was reset",
                        "start": 12,
                        "step": 1,
                        "stop": 13,
                        "width": 32,
                    },
                    "eth100g_tx_total_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets sent on the 100G ethernet since it was reset",
                        "start": 15,
                        "step": 1,
                        "stop": 16,
                        "width": 32,
                    },
                    "firmware_label": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Firmware Label",
                        "start": 8,
                        "step": 1,
                        "stop": 9,
                        "width": 32,
                    },
                    "firmware_major_version": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Major version number",
                        "start": 5,
                        "step": 1,
                        "stop": 6,
                        "width": 16,
                    },
                    "firmware_minor_version": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Minor version number",
                        "start": 6,
                        "step": 1,
                        "stop": 7,
                        "width": 16,
                    },
                    "firmware_patch_version": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Patch version number",
                        "start": 7,
                        "step": 1,
                        "stop": 8,
                        "width": 16,
                    },
                    "firmware_personality": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Firmware function - PST/PSS/ZOOM/CORR",
                        "start": 9,
                        "step": 1,
                        "stop": 10,
                        "width": 32,
                    },
                    "qsfpgty_resets": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Reset 100G ethernet interface",
                        "start": 3,
                        "step": 1,
                        "stop": 4,
                        "width": 1,
                    },
                    "status_clocks_locked": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "All clocks locked",
                        "start": 2,
                        "step": 1,
                        "stop": 3,
                        "width": 1,
                    },
                    "time_uptime": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of seconds since programming",
                        "start": 10,
                        "step": 1,
                        "stop": 11,
                        "width": 32,
                    },
                },
                "start": 0,
                "step": 17,
                "stop": 17,
                "type": "REG",
            }
        },
        "start": 0,
        "step": 17,
        "stop": 17,
    },
    "array": {
        "slaves": {
            "my_array": {
                "fields": {
                    "data": {
                        "access_mode": "RW",
                        "bit_offset": 32,
                        "default": 0,
                        "description": "Dummy Array",
                        "start": 0,
                        "step": 1,
                        "stop": 1024,
                        "width": 32,
                    }
                },
                "start": 0,
                "step": 1024,
                "stop": 1024,
                "type": "RAM",
            }
        },
        "start": 32,
        "step": 1024,
        "stop": 1024 + 32,
    },
}
